import tensorflow as tf
from hw1_utils import load_data
# >> You are free to add other packages from tensorflow <<

mnist_path = 'mnist.pkl.gz'


def build_model(x, y, learning_rate=1.0, input_dim=784, num_class=10):
    """build_model Build a Tensorflow model of logistic regression

    Arguments:
        x {tf.Tensor} -- Symbolic tensor for input data.
        y {tf.Tensor} -- Symbolic tensor for ground truth output data.

    Keyword Arguments:
        learning_rate {float} -- The learning rate for each epoch
        input_dim {int} -- The number of dimensions for the input data
             (default: {784})
        num_class {int} -- The number of classes (default: {10})

    Returns:
        {tf.Tensor} -- A symbolic tensor of the computation of accuracy
        {tf.Tensor} -- A symbolic tensor of the computation of loss
        {tf.Tensor} -- A symbolic tensor of the computation of updating weight
        {tf.Tensor} -- A symbolic tensor of the computation of updating bias
    """
    accuracy_op = None
    loss_op = None
    update_W_op = None
    update_b_op = None

    # >> Start of your code. <<

    # >> End of your code. <<

    return accuracy_op, loss_op, update_W_op, update_b_op


def run_tf(epochs=10, learning_rate=1.0, batch_size=64):
    """build_model Build a Keras model of logistic regression

    Keyword Arguments:
        epochs {int} -- The number of epochs for training.
        learning_rate {float} -- The learning rate for each epoch
        batch_size {int} -- The number of samples in each mini-batch

    Returns:
        {float} -- test accuracy
    """

    train_X, train_y, val_X, val_y, test_X, test_y = load_data(mnist_path)

    input_dim = train_X.shape[1]
    num_class = len(set(train_y))

    tf.reset_default_graph()

    X = tf.placeholder(tf.float32, shape=[None, input_dim])
    Y = tf.placeholder(tf.float32, shape=[None, num_class])

    test_accuracy = None

    # >> Start of your code. <<

    # >> End of your code. <<

    print('Test Accuracy: {}'.format(test_accuracy))

    return test_accuracy


if __name__ == '__main__':
    run_tf()
